datablock AudioProfile(colorMagicShotSound)
{
   filename    = "./pow.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(redMagicParticle)
{
	dragCoefficient = 2;
	windCoefficient = 0;
	gravityCoefficient = 0;
	inheritedVelFactor = 0;
	constantAcceleration = 0;
	lifetimeMS = 1000;
	lifetimeVarianceMS = 250;
	textureName = "./square";
	spinSpeed = 0;
	spinRandomMin = -300;
	spinRandomMax = 300;
	useInvAlpha = false;

	colors[0] = "1 0 0 1";
	colors[1] = "1 0 0 0";
	sizes[0] = 0.4;
	sizes[1] = 0.3;
};

datablock ParticleEmitterData(redMagicEmitter)
{
	ejectionPeriodMS = 15;
	periodVarianceMS = 0;
	ejectionVelocity = 1.5;
	velocityVariance = 1;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 180;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = redMagicParticle;

	uiName = "Magic Red";
};

datablock ExplosionData(redMagicExplosion)
{
	lifeTimeMS = 250;

	particleEmitter = redMagicEmitter;
	particleDensity = 75;
	particleRadius = 1;

	emitter[0] = redMagicEmitter;

	faceViewer = true;
	explosionScale = "1 1 1";

	shakeCamera = false;
	camShakeFreq = "30 30 30";
	camShakeAmp = "7 2 7";
	camShakeDuration = 0.6;
	camShakeRadius = 2.5;

	lightStartRadius = 0;
	lightEndRadius = 0;
	lightStartColor = "1 1 1";
	lightEndColor = "1 1 1";
};

datablock ProjectileData(redMagicProjectile)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	directDamage = 0;
	directDamageType = $DamageType::Default;

	impactImpulse = 400;
	verticalImpulse = 400;
	explosion = redMagicExplosion;
	particleEmitter = redMagicEmitter;

	muzzleVelocity = 100;
	velInheritFactor = 0;

	armingDelay = 0;
	lifetime = 20000;
	fadeDelay = 20000;
	bounceElasticity = 0.5;
	bounceFriction = 0.5;
	isBallistic = false;

	hasLight = false;
	lightRadius = 1;
	lightColor = "0 0 0";

	uiName = "Magic Red";
};

datablock ItemData(redMagicItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "base/data/shapes/empty.dts";
	rotate = false;
	mass = 0.2;
	density = 0.1;
	elasticity = 0.8;
	friction = 0.2;
	emap = true;

	uiName = "Magic Red";
	iconName = "./icon_redmagic";
	doColorShift = true;
	colorShiftColor = "1 0 0 1";

	image = redMagicImage;
	canDrop = true;
};

datablock ShapeBaseImageData(redMagicImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = "0 0 0";

	correctMuzzleVector = true;

	className = "WeaponImage";
	item = redMagicItem;
	ammo = " ";
	projectile = redMagicProjectile;
	projectileType = Projectile;

	melee = false;
	armReady = true;

	stateName[0]                   = "Activate";
	stateTimeoutValue[0]           = 0.15;
	stateTransitionOnTimeout[0]    = "Ready";

	stateName[1]                   = "Ready";
	stateTransitionOnTriggerDown[1]= "Fire";
	stateAllowImageChange[1]       = true;
	stateSequence[1]               = "Ready";
	stateEmitter[1]                = redMagicEmitter;
	stateEmitterTime[1]            = 600;

	stateName[2]                   = "Fire";
	stateTransitionOnTimeout[2]    = "Reload";
	stateTimeoutValue[2]           = 0.75;
	stateFire[2]                   = true;
	stateAllowImageChange[2]       = true;
	stateScript[2]                 = "onFire";
	stateSound[2]		       = colorMagicShotSound;
	stateWaitForTimeout[2]         = true;

	stateName[3]                   = "Reload";
	stateTransitionOnTriggerUp[3]  = "Ready";
};

datablock ParticleData(yellowMagicParticle : redMagicParticle)
{
	textureName = "base/data/particles/star1.png";

	colors[0] = "1 1 0 1";
	colors[1] = "1 1 0 0";
};

datablock ParticleEmitterData(yellowMagicEmitter : redMagicEmitter)
{
	particles = yellowMagicParticle;

	uiName = "Magic Yellow";
};

datablock ExplosionData(yellowMagicExplosion : redMagicExplosion)
{
	particleEmitter = yellowMagicEmitter;

	emitter[0] = yellowMagicEmitter;
};

datablock ProjectileData(yellowMagicProjectile : redMagicProjectile)
{
	explosion = yellowMagicExplosion;
	particleEmitter = yellowMagicEmitter;

	uiName = "Magic Yellow";
};

datablock ItemData(yellowMagicItem : redMagicItem)
{
	uiName = "Magic Yellow";

	iconName = "./icon_yellowmagic";

	colorShiftColor = "1 1 0 1";

	image = yellowMagicImage;
};

datablock ShapeBaseImageData(yellowMagicImage : redMagicImage)
{
	item = yellowMagicItem;

	projectile = yellowMagicProjectile;

	stateEmitter[1]                = yellowMagicEmitter;
};

datablock ParticleData(greenMagicParticle : redMagicParticle)
{
	textureName = "./triangle.png";

	colors[0] = "0 1 0 1";
	colors[1] = "0 1 0 0";
};

datablock ParticleEmitterData(greenMagicEmitter : redMagicEmitter)
{
	particles = greenMagicParticle;

	uiName = "Magic Green";
};

datablock ExplosionData(greenMagicExplosion : redMagicExplosion)
{
	particleEmitter = greenMagicEmitter;

	emitter[0] = greenMagicEmitter;
};

datablock ProjectileData(greenMagicProjectile : redMagicProjectile)
{
	explosion = greenMagicExplosion;
	particleEmitter = greenMagicEmitter;

	uiName = "Magic Green";
};

datablock ItemData(greenMagicItem : redMagicItem)
{
	uiName = "Magic Green";

	iconName = "./icon_greenmagic";

	colorShiftColor = "0 1 0 1";

	image = greenMagicImage;
};

datablock ShapeBaseImageData(greenMagicImage : redMagicImage)
{
	item = greenMagicItem;

	projectile = greenMagicProjectile;

	stateEmitter[1]                = greenMagicEmitter;
};

datablock ParticleData(blueMagicParticle : redMagicParticle)
{
	textureName = "base/data/particles/dot.png";

	colors[0] = "0 0 1 1";
	colors[1] = "0 0 1 0";
};

datablock ParticleEmitterData(blueMagicEmitter : redMagicEmitter)
{
	particles = blueMagicParticle;

	uiName = "Magic Blue";
};

datablock ExplosionData(blueMagicExplosion : redMagicExplosion)
{
	particleEmitter = blueMagicEmitter;

	emitter[0] = blueMagicEmitter;
};

datablock ProjectileData(blueMagicProjectile : redMagicProjectile)
{
	explosion = blueMagicExplosion;
	particleEmitter = blueMagicEmitter;

	uiName = "Magic Blue";
};

datablock ItemData(blueMagicItem : redMagicItem)
{
	uiName = "Magic Blue";

	iconName = "./icon_bluemagic";

	colorShiftColor = "0 0 1 1";

	image = blueMagicImage;
};

datablock ShapeBaseImageData(blueMagicImage : redMagicImage)
{
	item = blueMagicItem;

	projectile = blueMagicProjectile;

	stateEmitter[1]                = blueMagicEmitter;
};

package onMagicRedHit
{
function redMagicProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	if(%col.getClassName() $= "fxDTSBrick")
	{
		$InputTarget_["Self"] = %col;
		$InputTarget_["Player"] = %obj.client.player;
		$InputTarget_["Client"] = %obj.client;
		if($Server::LAN)
		{   //Will work for Slayer and TDM
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
		}
		else
		{
			if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))
			{
				$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);
			}
			else
			{
				$InputTarget_["MiniGame"] = 0;
			}
		}
		%col.processInputEvent(onMagicRedHit,%obj.client);
	}
}
};
activatePackage(onMagicRedHit);

package onMagicYellowHit
{
function yellowMagicProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	if(%col.getClassName() $= "fxDTSBrick")
	{
		$InputTarget_["Self"] = %col;
		$InputTarget_["Player"] = %obj.client.player;
		$InputTarget_["Client"] = %obj.client;
		if($Server::LAN)
		{   //Will work for Slayer and TDM
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
		}
		else
		{
			if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))
			{
				$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);
			}
			else
			{
				$InputTarget_["MiniGame"] = 0;
			}
		}
		%col.processInputEvent(onMagicYellowHit,%obj.client);
	}
}
};
activatePackage(onMagicYellowHit);

package onMagicGreenHit
{
function greenMagicProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	if(%col.getClassName() $= "fxDTSBrick")
	{
		$InputTarget_["Self"] = %col;
		$InputTarget_["Player"] = %obj.client.player;
		$InputTarget_["Client"] = %obj.client;
		if($Server::LAN)
		{   //Will work for Slayer and TDM
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
		}
		else
		{
			if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))
			{
				$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);
			}
			else
			{
				$InputTarget_["MiniGame"] = 0;
			}
		}
		%col.processInputEvent(onMagicGreenHit,%obj.client);
	}
}
};
activatePackage(onMagicGreenHit);

package onMagicBlueHit
{
function blueMagicProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	if(%col.getClassName() $= "fxDTSBrick")
	{
		$InputTarget_["Self"] = %col;
		$InputTarget_["Player"] = %obj.client.player;
		$InputTarget_["Client"] = %obj.client;
		if($Server::LAN)
		{   //Will work for Slayer and TDM
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
		}
		else
		{
			if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))
			{
				$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);
			}
			else
			{
				$InputTarget_["MiniGame"] = 0;
			}
		}
		%col.processInputEvent(onMagicBlueHit,%obj.client);
	}
}
};
activatePackage(onMagicBlueHit);